<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="包裹id" prop="consId">
        <el-input v-model="queryParams.consId" placeholder="请输入包裹id" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="包裹明细id" prop="consItemId">
        <el-input v-model="queryParams.consItemId" placeholder="请输入包裹明细id" clearable
                  @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="异常类型" prop="exceptionType">
        <el-select v-model="queryParams.exceptionType" placeholder="请选择异常类型" clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.CONS_EXCEPTION_TYPE)"
                     :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="异常状态" prop="exceptionStatus">
        <el-select v-model="queryParams.exceptionStatus" placeholder="请选择异常状态" clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.CONS_EXCEPTION_STATUS)"
                     :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="" prop="bpmId">
        <el-input v-model="queryParams.bpmId" placeholder="请输入" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:cons-exception:create']">新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
                   :loading="exportLoading"
                   v-hasPermi="['ecw:cons-exception:export']">导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="包裹id" align="center" prop="consId" />
      <el-table-column label="包裹明细id" align="center" prop="consItemId" />
      <el-table-column label="异常类型" align="center" prop="exceptionType">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CONS_EXCEPTION_TYPE" :value="scope.row.exceptionType" />
        </template>
      </el-table-column>
      <el-table-column label="异常说明" align="center" prop="exceptionRemark" />
      <el-table-column label="异常状态" align="center" prop="exceptionStatus">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CONS_EXCEPTION_STATUS" :value="scope.row.exceptionStatus" />
        </template>
      </el-table-column>
      <el-table-column label="" align="center" prop="bpmId" />
      <el-table-column label="" align="center" prop="bpmStatus" />
      <el-table-column label="" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)">处理</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList" />

    <ExceptionHandling :showException.sync="showException" :id="id" @determine="getList"></ExceptionHandling>

  </div>
</template>

<script>
import {
  createConsException,
  updateConsException,
  deleteConsException,
  getConsExceptionPage,
  exportConsExceptionExcel
} from "@/api/ecw/consException"
import ExceptionHandling from "@/views/ecw/consException/components/ExceptionHandling.vue"

export default {
  name: "ConsException",
  components: {
    ExceptionHandling
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 集运异常列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        consId: null,
        consItemId: null,
        exceptionType: null,
        exceptionRemark: null,
        exceptionStatus: null,
        bpmId: null,
        bpmStatus: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        consId: [{ required: true, message: "包裹id不能为空", trigger: "blur" }],
        exceptionType: [{
          required: true,
          message: "异常类型，来自于字典表cons_exception_type不能为空",
          trigger: "change"
        }]
      },
      showException: true,
      id: null
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true
      // 处理查询参数
      let params = { ...this.queryParams }
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, "createTime")
      // 执行查询
      getConsExceptionPage(params).then(response => {
        this.list = response.data.list
        this.total = response.data.total
        this.loading = false
      })
    },
    /** 取消按钮 */
    cancel() {
      this.open = false
      this.reset()
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        consId: undefined,
        consItemId: undefined,
        exceptionType: undefined,
        exceptionRemark: undefined,
        exceptionStatus: undefined,
        bpmId: undefined,
        bpmStatus: undefined
      }
      this.resetForm("form")
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = []
      this.resetForm("queryForm")
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = "添加集运异常"
    },
    /** 修改按钮操作 */
    handleUpdate(row) {

    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return
        }
        // 修改的提交
        if (this.form.id != null) {
          updateConsException(this.form).then(response => {
            this.$modal.msgSuccess("修改成功")
            this.open = false
            this.getList()
          })
          return
        }
        // 添加的提交
        createConsException(this.form).then(response => {
          this.$modal.msgSuccess("新增成功")
          this.open = false
          this.getList()
        })
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id
      this.$modal.confirm("是否确认删除集运异常编号为\"" + id + "\"的数据项?").then(function() {
        return deleteConsException(id)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess("删除成功")
      }).catch(() => {
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = { ...this.queryParams }
      params.pageNo = undefined
      params.pageSize = undefined
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, "createTime")
      // 执行导出
      this.$modal.confirm("是否确认导出所有集运异常数据项?").then(() => {
        this.exportLoading = true
        return exportConsExceptionExcel(params)
      }).then(response => {
        this.$download.excel(response, "${table.classComment}.xls")
        this.exportLoading = false
      }).catch(() => {
      })
    }
  }
}
</script>
